; BPREVIEW.LSP :  ̸  α׷
; ۼ       : 1995. 12. 16. ()
; ۼ       : ֹ

; 뵵
;
; BPREVIEW(Block Preview)  insert ϱ  ̸ ִ
;  Ѵ. δ  ʴ ƼƼ ֱ  ⺻
; ƼƼ鿡  Ϻ ó  ״ preview  
;    ȴ.

; 
;
; AutoCAD   Ѵ.
;
; Command: (load "BPREVIEW")
; C:BPREVIEW
; Command: BPREVIEW
;
; ȭڰ Ÿ ʿ ִ  ߿ ϳ Ѵ.
; õ  ȭ  ̹  ׷.
;  Ŭϰų OK ư ϸ ش  insert  ִ.

;   
;
;  ƼƼ ִ ũ     ʴ ƼƼ鿡 
; ó  ߰  ٶ.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 
;
; #DIMX    : ̹ ڽ ִ X 
; #DIMY    : ̹ ڽ ִ Y 
; #MINX    :  ּ X 
; #MINY    :  ּ Y 
; #SCALE   : ǥ 
; #ARCSTEP : ȣ    к

(setq #ARCSTEP 16)

;   ̿ ּҰ   Ѵ.

(defun min-point (p1 p2)
    (list (min (car p1) (car p2))
          (min (cadr p1) (cadr p2))
    )
)

;   ̿ ִ밪   Ѵ.

(defun max-point (p1 p2)
    (list (max (car p1) (car p2))
          (max (cadr p1) (cadr p2))
    )
)

;  ̾  ȣ ´.

(defun get-layer-color (lyname / tlist co)
    (setq tlist (tblsearch "LAYER" lyname))
    (if tlist
        (setq co (cdr (assoc 62 tlist)))
        (setq co 7)
    )
    co
)

;  ǥ ȭ ǥ ȯѴ.

(defun get-xpoint (po)
    (list (fix (+ (* 0.05 #DIMX) (* (- (car po) #MINX) #SCALE)))
          (fix (- (* 0.95 #DIMY) (* (- (cadr po) #MINY) #SCALE)))
    )
)

; ȭڿ  ׸.

(defun vector_line (sp ep co / p1 p2)
    (setq p1 (get-xpoint sp))
    (setq p2 (get-xpoint ep))
    (vector_image (car p1) (cadr p1) (car p2) (cadr p2) co)
)

; ȭڿ ȣ ׸.

(defun vector_arc (cen rad sang eang co / ang step p1 p2)
    (if (< eang sang) (setq eang (+ eang (* 2.0 PI))))
    (setq ang (- eang sang)
          step (/ ang #ARCSTEP)
          eang (+ sang step)
    )
    (repeat #ARCSTEP
        (setq p1 (polar cen sang rad))
        (setq p2 (polar cen eang rad))
        (vector_line p1 p2 co)
        (setq sang eang eang (+ eang step))
    )
)

; LINE  ó

(defun draw-line (el co mode / p1 p2 ext)
    (setq p1 (cdr (assoc 10 el)) p2 (cdr (assoc 11 el)))
    (setq ext (list (min-point p1 p2) (max-point p1 p2)))
    (if mode (vector_line p1 p2 co))
    ext
)

; POINT  ó

(defun draw-point (el co mode / p1 ext)
    (setq p1 (cdr (assoc 10 el)))
    (setq ext (list p1 p1))
    (if mode (vector_line p1 p1 co))
    ext
)

; CIRCLE  ó

(defun draw-circle (el co mode / cen rad ext)
    (setq cen (cdr (assoc 10 el)))
    (setq rad (cdr (assoc 40 el)))

    (setq ext (list rad rad rad))
    (if mode (vector_arc cen rad 0.0 (* 2.0 PI) co))
    (list (mapcar '- cen ext) (mapcar '+ cen ext))
)

; ARC  ó

(defun draw-arc (el co mode / cen rad sang eang ext)
    (setq cen (cdr (assoc 10 el)))
    (setq rad (cdr (assoc 40 el)))
    (setq sang (cdr (assoc 50 el)))
    (setq eang (cdr (assoc 51 el)))
    ; ִũ  
    (setq ext (list rad rad rad))
    (if mode (vector_arc cen rad sang eang co))
    (list (mapcar '- cen ext) (mapcar '+ cen ext))
)

; TRACE  ó

(defun draw-trace (el co mode / p1 p2 p3 p4 extmin extmax)
    (setq p1 (cdr (assoc 10 el)))
    (setq p2 (cdr (assoc 11 el)))
    (setq p3 (cdr (assoc 12 el)))
    (setq p4 (cdr (assoc 13 el)))
    (setq extmin (min-point p2 p1)
          extmin (min-point p3 extmin)
          extmin (min-point p4 extmin)
    )
    (setq extmax (max-point p2 p1)
          extmax (max-point p3 extmax)
          extmax (max-point p4 extmax)
    )
    (if mode
        (progn
            (vector_line p1 p2 co)
            (vector_line p2 p4 co)
            (vector_line p4 p3 co)
            (vector_line p3 p1 co)
        )
    )
    (list extmin extmax)
)

; SOLID  ó

(defun draw-solid (el co mode / p1 p2 p3 p4 extmin extmax)
    (setq p1 (cdr (assoc 10 el)))
    (setq p2 (cdr (assoc 11 el)))
    (setq p3 (cdr (assoc 12 el)))
    (setq p4 (cdr (assoc 13 el)))
    (setq extmin (min-point p2 p1)
          extmin (min-point p3 extmin)
          extmin (min-point p4 extmin)
    )
    (setq extmax (max-point p2 p1)
          extmax (max-point p3 extmax)
          extmax (max-point p4 extmax)
    )
    (if mode
        (progn
            (vector_line p1 p2 co)
            (vector_line p2 p4 co)
            (vector_line p4 p3 co)
            (vector_line p3 p1 co)
        )
    )
    (list extmin extmax)
)

; TEXT  ó

(defun draw-text (el co mode / org hgt ang ext len p1 p2 p3 p4 extmin extmax)
    (setq org (cdr (assoc 10 el)))
    (setq hgt (cdr (assoc 40 el)))
    (setq ang (cdr (assoc 50 el)))
    ; ִũ  
    (setq ext (textbox el))
    (setq len (distance (car ext) (cadr ext)))
    (setq len (sqrt (abs (- (* len len) (* hgt hgt)))))
    (setq p1 org
          p2 (polar p1 ang len)
          p3 (polar p2 (+ ang (/ PI 2.0)) hgt)
          p4 (polar p1 (+ ang (/ PI 2.0)) hgt)
    )
    (setq extmin (min-point p2 p1)
          extmin (min-point p3 extmin)
          extmin (min-point p4 extmin)
    )
    (setq extmax (max-point p2 p1)
          extmax (max-point p3 extmax)
          extmax (max-point p4 extmax)
    )
    (if mode
        (progn
            (vector_line p1 p2 co)
            (vector_line p2 p3 co)
            (vector_line p3 p4 co)
            (vector_line p4 p1 co)
        )
    )
    (list extmin extmax)
)

; POLYLINE  ó

(defun draw-pline (ent co mode / el pclose sp p1 extmin extmax p2)
    (setq el (entget ent))
    (if (and (cdr (assoc 70 el)) 1) (setq pclose T))

    (setq ent (entnext ent))
    (setq el (entget ent))
    (setq p1 (cdr (assoc 10 el)))
    (if pclose (setq sp p1))
    (setq extmin p1 extmax p1)

    (setq ent (entnext ent))
    (setq el (entget ent))
    (while (= "VERTEX" (cdr (assoc 0 el)))
        (setq p2 (cdr (assoc 10 el)))
        (setq extmin (min-point extmin p2))
        (setq extmax (max-point extmax p2))
        (if mode (vector_line p1 p2 co))
        (setq p1 p2)
        (setq ent (entnext ent))
        (setq el (entget ent))
    )

    (if (and pclose mode) (vector_line sp p2 co))

    (list extmin extmax)
)

; mode   ƼƼ ִũ⸦ ϰų ƼƼ ȭڿ ׸.

(defun draw-block (ent mode / extmin extmax el etype co ext)
    (setq extmin (list 1.0e10 1.0e10 1.0e10))
    (setq extmax (list -1.0e10 -1.0e10 -1.0e10))
    (princ "\n")
    (while ent
        (setq el (entget ent))
        (setq etype (cdr (assoc 0 el)))
        (setq co (cdr (assoc 62 el)))
        (if (= co 0) (setq co 7))
        (if (not co) (setq co (get-layer-color (cdr (assoc 8 el)))))
        (setq ext nil)
        (cond
            ((= etype "LINE")     (setq ext (draw-line el co mode)))
            ((= etype "POINT")    (setq ext (draw-point el co mode)))
            ((= etype "CIRCLE")   (setq ext (draw-circle el co mode)))
            ((= etype "ARC")      (setq ext (draw-arc el co mode)))
            ((= etype "TRACE")    (setq ext (draw-trace el co mode)))
            ((= etype "SOLID")    (setq ext (draw-solid el co mode)))
            ((= etype "TEXT")     (setq ext (draw-text el co mode)))
            ((= etype "POLYLINE") (setq ext (draw-pline ent co mode)))
        )
        (if ext
            (progn
                (setq extmin (min-point extmin (car ext)))
                (setq extmax (max-point extmax (cadr ext)))
                (princ ".")
            )
        )
        (setq ent (entnext ent))
    )
    (princ "\n")
    (list extmin extmax)
)

;     ̹ ڽ ׸.

(defun preview-block (bname / binfo ent ext emin emax sx sy)
    (setq binfo (tblsearch "BLOCK" bname))      ;    ´.
    (setq ent (cdr (assoc -2 binfo)))           ;  ƼƼ ̸ ´.

    (setq #DIMX (dimx_tile "preview_box"))
    (setq #DIMY (dimy_tile "preview_box"))
    (start_image "preview_box")
    (fill_image 0 0 #DIMX #DIMY -2)
    (end_image)

    (setq ext (draw-block ent nil))             ;  ִ ũ⸦ Ѵ.
    (setq emin (car ext) emax (cadr ext))

    ;  ° ȭ Ѵ.
    (setq #MINX (car emin))
    (setq #MINY (cadr emin))
    (setq sx (- (car emax) (car emin)))
    (if (zerop sx)
        (setq sx 1.0e10)
        (setq sx (* 0.9 (/ #DIMX sx)))
    )
    (setq sy (- (cadr emax) (cadr emin)))
    (if (zerop sy)
        (setq sy 1.0e10)
        (setq sy (* 0.9 (/ #DIMY sy)))
    )
    (setq #SCALE (min sx sy))

    (start_image "preview_box")
    (draw-block ent T)                          ;   ׸.
    (end_image)
)

;  Ʈ LIST BOX   Ʈ Ѵ.

(defun get-block-list ( / tl in ln blist)
    (start_list "block_list")
    (setq tl (tblnext "BLOCK" T) in 0)
    (while tl
        (setq ln (cdr (assoc 2 tl)))
        (add_list ln)
        (setq blist (append blist (list ln)))
        (setq in (1+ in))
        (setq tl (tblnext "BLOCK"))
    )
    (end_list)
    blist
)

; LIST BOX  ׸ õǾ  Ǵ CALL BACK Լ
; õ  ش.

(defun do-block-list (blist / bname)
    (setq bname (nth (atoi (get_tile "block_list")) blist))
    (preview-block bname)
    bname
)

; ü α׷ C:BPREVIEW Լ Ѵ.

(defun C:BPREVIEW ( / id blist bname result)
    (setq id (load_dialog "BPREVIEW.DCL"))
    (new_dialog "block_preview" id)

    (setq blist (get-block-list))

    (action_tile "block_list" "(setq bname (do-block-list blist))")
    (action_tile "cancel" "(done_dialog 0)")
    (action_tile "accept" "(done_dialog 1)")

    (setq result (start_dialog))
    (if (= result 1) (command "INSERT" bname))
    (princ)
)
